100 DEFINT A-Y:V=16414:DIM T(40),X(40),Y(40),DX(40),DY(40),TT(40):FR=0:CO=0:S1=0:CR=0
120 EN=0:FS=0:FD=0:FX=0:FY=0:CE=64:LE=0:CC=10:AC=0:SC=0:KZ=0:LC=0:REM FY=Last Fuel Can Y DS=0
130 MM = 5*64+20
200 CLS : LPRINT "4"

300 POKEV,PEEK(V)-1 : INPUT N,Z,X,Y : POKEV,PEEK(V)+1 :IF N>127 THEN 350
310 IF Z<32767 THEN T=INT(Z) ELSE T=-1 : REM If score > 32767 then score = -1 (To keep T an INT for speed)
320 IF T(N)=T THEN DX(N)=X-X(N):DY(N)=Y-Y(N) ELSE DX(N)=0:DY(N)=0
330 T(N)=T : X(N)=X : Y(N)=Y : GOTO 300
350 IF N=129 THEN END : REM RUN
355 S1=T: SC=X: AC=Y
360 IF FR < 110 THEN 970

390 REM Main Loop
400 GOSUB 50000 : REM Stats
425 GOSUB 8000	: REM Map Enemies
450 GOSUB 9000  : REM Avoid Bombs
500 GOSUB 10000 : REM Avoid Enemies
600 GOSUB 23000 : REM Check Fuel Cans
700 GOSUB 11000 : REM Shoot Enemy
800 GOSUB 14000 : REM Flagship/Centre
900 GOSUB 18000 : REM Check Slicer
950 GOSUB 17000 : REM Check Swarm
965 GOSUB 52000 : REM Clear Status
970 FR=FR+1
980 LPRINT
990 GOTO 300

8000 REM Map Enemies
8025 FOR ME = 36 TO 2 STEP -1  : REM Fuel Cans 2 to 11
8030 TT(ME)=0
8040 IF T(ME)=0 THEN 8390
8060 IF X(ME)<1 THEN 8390
8220 T1=(40-Y(ME))/4
8240 T=X(ME)+T1*DX(ME)
8260 DI=T-X(0)
8280 IF DI<0 THEN T=T-2
8300 IF DI>0 THEN T=T+2
8312 IF DI<>0 THEN IF Y(ME)>30 THEN T=T+DX(ME) : REM Low Adjust
8316 IF DI<0 THEN IF Y(ME)<11 THEN T=T-2 : REM High Adjust Added
8317 IF DI>0 THEN IF Y(ME)<11 THEN T=T+2 : REM High Adjust Added
8330 IF T(ME)=6 THEN T=T-4 : REM Slicer Adjust
8340 IF T(ME)=2 THEN IF DX(ME)<1 THEN T=T-3+(DX(ME)*2) ELSE IF DX(ME)>0 THEN T=T+3+DX(ME) : REM Fuel Can Adjust
8350 IF CC=1 THEN IF T(ME)<>6 THEN IF ABS(T-CE)<3 THEN IF DX(ME)<0 THEN T=T-1 ELSE T=T+1 : REM Adjust since 1 can target
8360 TT(ME)=T
8390 NEXT
8400 RETURN

9000 REM Avoid Bombs
9030 BA=0:BX=0:BY=0
9040 FOR L = 37 TO 39 : REM Enemy Shots
9060 IF T(L)=0 THEN 9200
9070 BY=Y(L)
9080 IF BY<39 OR BY>46 THEN 9200
9130 BX = X(L)-3-X(0)
9140 IF BX>6 OR BX<-7 THEN 9200 : REM was >5 needs to be 6 or 7 @15480
9150 IF BX<1 THEN BA=-1:L=39:GOTO 9200 ELSE BA=1:L=39:GOTO 9200
9200 NEXT
9210 REM ?@3*64,"BombAvoid X(0) BX BA:";X(0);BX;BA;"   ";
9230 IF BA=0 THEN 9990
9250 MS$="BOMB AVOID":GOSUB 51000:IF BA=1 THEN LPRINT "<"; ELSE LPRINT ">";
9990 RETURN

10000 REM Avoid Enemies
10050 ML=0:MR=0:ES=0:EA=0
10100 FOR L = 12 TO 36 : REM 12-36 Enemy Ships
10120 IF T(L)=0 THEN 10190
10140 IF Y(L)<41 THEN 10190
10150 IF Y(L)=48 THEN 10190 : REM Ignore Slicer
10171 GOSUB 10500 : IF ML<>0 THEN 10190
10181 GOSUB 10600 : IF MR<>0 THEN 10190
10185 IF X(0)=X(L) THEN IF DX(L)>0 THEN ML=1:ES=1 ELSE MR=1:ES=1: REM Enemy directly above
10190 NEXT
10196 IF ES=1 THEN GOSUB 20000
10200 IF ML>0 AND MR>0 THEN LPRINT "!"; : MS$="PANIC NUKE" : GOSUB 51000 : GOTO 10299
10201 IF KZ=1 THEN MS$="KAMAKAZI":GOSUB 51000 : GOTO10299
10221 IF ML=1 THEN LPRINT "<"; : EA=1 : MS$="PANIC MODE ML1" : GOSUB 51000 : GOTO 10299
10241 IF MR=1 THEN LPRINT ">"; : EA=1 : MS$="PANIC MODE MR1" : GOSUB 51000 : GOTO 10299
10251 IF ML=3 THEN LPRINT "<<";: EA=1 : MS$="PANIC MODE ML3" : GOSUB 51000 : GOTO 10299
10261 IF MR=3 THEN LPRINT ">>";: EA=1 : MS$="PANIC MODE MR3" : GOSUB 51000
10299 RETURN

10500 REM Move according to how fast enemy approaches ML
10501 XA=X(L)-X(0)
10502 IF (XA<1) OR (XA>12) THEN RETURN
10505 ML=1
10510 IF ABS(DX(L))>1 OR XA<3 THEN ML=3
10520 RETURN

10600 REM Move according to how fast enemy approaches MR
10601 XA=X(0)-X(L)
10602 IF (XA<1) OR (XA>14) THEN RETURN
10605 MR=1
10610 IF ABS(DX(L))>1 OR XA<3 THEN MR=3
10620 RETURN


11000 REM Pick a Target Enemy
11200 IF T(EN)=0 THEN EN=0
11210 IF LE>0 THEN IF T(LE)=0 THEN LE=0:L2=0
11220 IF L2>0 THEN L2=L2-1 : REM IF T(LE)<>6 THEN LE=0
11225 IF L2=0 THEN LE=0
11320 IF EN<>0 THEN 11400
11325 LO=0: LY=0
11330 FOR L = 36 TO 12 STEP -1
11340 IF LE=L THEN GOTO 11360
11355 IF T(L)<>0 THEN IF T(L)>5 AND X(L)>0 THEN GOSUB 12000
11360 NEXT
11370 IF LO<>0 THEN IF EN<1 THEN EN=LO : FS=0
11390 REM End Check Enemies
11400 REM Chase and Shoot enemy  PlayerX=X(0), EnemyX=X(EN)
11410 IF T(EN)=2 THEN IF Y(EN)>=47 THEN EN=0 : CR=1 : REM Can returned to ground
11420 IF T(EN)=6 THEN IF KZ=0 THEN IF Y(EN)>40 THEN EN=0 : REM Slicer is too close drop it
11425 IF T(EN)=6 THEN IF KZ=1 THEN IF Y(EN)>42 THEN EN=0
11430 IF T(EN)=2 THEN IF DY(EN)<0 THEN IF CC>1 THEN IF Y(EN)<22 THEN EN=0 : REM Abandon can retrieval
11440 IF T(EN)<>2 THEN IF Y(EN)>42 THEN EN=0 : REM Dont chase enemy crawling across bottom
11450 IF EN=0 THEN 11999
11470 DI = TT(EN)-X(0)
11471 IF X(0)=TT(EN) OR X(0)=TT(EN)+1 OR X(0)=TT(EN)-1 GOSUB 20000 : GOTO 11999
11473 IF T(EN)=6 THEN IF X(EN)=1 THEN IF X(0)=TT(EN)+1 THEN GOSUB 20000 : GOTO 11999 : REM Slicer @X1 special case
11475 REM No shot taken at target enemy so check other enemies
11478 IF ABS(DI)<5 THEN 11550 : REM Too close to enemy save shot
11480 FOR L = 36 TO 12 STEP -1
11490 REM IF T(L)<>0 THEN IF TT(L)>0 THEN IF X(0)=TT(L) GOSUB 20000 : L=12
11495 IF T(L)<>0 THEN IF Y(L)>20 THEN IF TT(L)>0 THEN IF (X(0)>=TT(L)-1 AND X(0)<=TT(L)+1) GOSUB 20000 : L=12
11500 NEXT
11550 IF BA<>0 THEN 11999 : REM Dont override Bomb Avoid!
11560 IF EA<>0 THEN 11999 : REM Dont override Enemy Avoid!
11600 IF DI<0 THEN IF DI<-3 OR DX(EN)=-3 THEN LPRINT "<("; ELSE LPRINT "<";
11700 IF DI>0 THEN IF DI>3 OR DX(EN)=3 THEN LPRINT ">)"; ELSE LPRINT ">";
11999 RETURN

12000 REM Set Target Enemy
12050 IF T(L)=6 THEN IF Y(L)>40 THEN RETURN : REM Slicer too low forget it.
12061 IF DY(L)<0 THEN RETURN : REM Ignore retreating enemy
12067 IF Y(L)>42 THEN RETURN : REM Ignore enemy on bottom row
12100 IF Y(L)>LY THEN LO=L
12200 LY=Y(L)
12300 RETURN

14000 REM IF no enemy go back to center unless flagship
14510 IF EN<>0 OR BA<>0 OR EA<>0 THEN 14990
14515 IF FS=0 GOSUB 15000
14520 IF FS<>0 THEN GOSUB 16000 : GOTO 14990 : REM Check for Flagship
14530 IF L2>0 THEN 14990 : REM Wait to see if shot lands
14540 IF X(0) > CE THEN LPRINT "<("; : GOTO 14990
14560 IF X(0) < CE THEN LPRINT ">)"; : GOTO 14990
14990 RETURN

15000 REM Spot Flagship
15020 FOR L = 12 to 36
15040 IF T(L) = 5 THEN FS=L:FX=X(FS):FD=0:L=36:MS$="FLAGSHIP":GOSUB 51000
15060 NEXT
15999 RETURN

16000 REM Chase flagship FS=Object, FX=Original Pos, FD=Direction
16010 IF T(FS) = 0 THEN FS=0:GOTO 16999
16020 IF FD <> 0 THEN 16120
16025 IF X(FS) > FX THEN FD=1
16039 IF X(FS) < FX THEN FD=-1
16050 IF FD=0 THEN 16999
16120 IF FD=1 THEN TX = X(FS)+10 ELSE TX = X(FS)-10 : REM TX = Target Position for Ship
16150 F3 = TX-X(0)
16160 IF F3<0 THEN IF F3<-3 THEN LPRINT "<("; ELSE LPRINT "<";
16180 IF F3>0 THEN IF F3>3 THEN LPRINT ">)"; ELSE LPRINT ">";
16200 REM Shoot flagship when in range
16220 IF X(0)=TX OR X(0)-1=TX OR X(0)+1=TX THEN GOSUB 20000 : REM LPRINT "F";
16999 RETURN


17000 REM If lots of enemies nuke'em, probably after shooting flagship
17010 CO=0:ML=0:MR=0
17020 FOR L = 12 to 36
17030 IF T(L)>0 THEN CO=CO+1:IF Y(L)>43 THEN GOSUB 10500:GOSUB 10600
17040 NEXT
17051 IF CO>7 AND AC>0 THEN GOSUB 17500
17099 RETURN

17500 REM Nuke plus Move?
17510 IF MR>0 AND ML>0 THEN 17540
17520 IF MR>0 THEN LPRINT "!>";:GOTO 17550
17530 IF ML>0 THEN LPRINT "!<";:GOTO 17550
17540 LPRINT "!";
17550 MS$="NUKE ENEMIES":GOSUB 51000
17560 RETURN

18000 REM Check for slicer and nuke'it if need be
18005 KZ=0 : REM Kamakazi!
18010 FOR L = 36 to 12 STEP -1
18012 IF T(L)<>6 THEN 18040
18015 ?@0, "Slicer:";"XY";X(L);Y(L);"DXY";DX(L);DY(L);"  ";
18020 IF Y(L)=48 AND AC=0 AND SC>1 THEN KZ=1:GOTO 18040
18025 IF CC=1 AND AC=0 AND SC>1 AND Y(L)>38 THEN KZ=1: GOTO 18040
18030 IF Y(L)>38 AND AC>0 THEN LPRINT"!"; : EN=0 : MS$="NUKE SLICER" : GOSUB 51000
18040 NEXT
18099 RETURN

20000 REM Take the Shot
20200 IF KZ=1 THEN IF T(EN)<>2 THEN 20999 : REM Kamakazi unless can
20250 IF T(EN)=2 THEN IF DY(EN)>0 THEN 20999 : REM Dont shoot at falling cans
20260 IF CR=1 THEN CR=0: GOTO 20999 : REM Dont waste shot when can lands
20300 IF T(1)=0 THEN LPRINT"F"; ELSE 20999
20500 IF T(EN)=6 THEN LE=EN:EN=0:L2=8 : REM LE Last Enemy, L2 Shot Count L2 was 6 not good
20999 RETURN

23000 REM Check Fuel Cans
23100 IF EN<0 THEN 23900 : REM Panic Mode
23214 IF T(EN)=2 THEN IF CC>2 THEN IF (X(EN)<32 OR X(EN)>96) THEN EN=0 : REM Switch to another enemy if can on outskirts (if more than 2 cans left)
23216 IF LC<>0 THEN IF CC=1 THEN IF Y(LC)>30 THEN LC=0:EN=0:GOTO23310:REM Catch Can
23220 IF T(EN)=2 THEN IF CC=1 THEN IF Y(EN)<7 THEN IF DY(EN)<0 THEN LPRINT "!";:GOTO 23900
23230 IF T(EN)=2 THEN IF CC=1 THEN IF DY(EN)>0 THEN IF Y(EN)<30 THEN LC=EN:EN=0
23281 IF T(EN)=2 THEN 23900 : REM Don't switch to another fuel can if working on 1st
23290 IF LC<>0 THEN 23900
23300 CE=0:CD=0
23310 FOR L=2 TO 11
23330 IF T(L)=2 THEN GOSUB 24000
23340 IF T(L)=2 THEN CE=CE+X(L):CD=CD+1
23350 NEXT
23360 IF CD>0 THEN CE=CE/CD:CC=CD ELSE CE=64
23900 RETURN

24000 REM Set Target Can
24010 IF Y(L)>43 THEN RETURN
24020 IF CC=1 THEN 24500 : REM Last can protect it!
24100 IF Y(L)<26 THEN RETURN
24120 IF CC>2 THEN IF X(L)<32 OR X(L)>96 THEN RETURN
24500 EN=L:FS=0
24999 RETURN

50000 REM Print Stats (0:Player, 1:Missile, 2-11:Fuel Cans, 12-36:Enemies, 37-39:Bombs)
50100 REM Objects:0:Dead,1:Ship,2:Fuel Can,3:Missile,4:Flagship,6:Slicer,7-14:Enemy 1-8,15:Solar Waster
50700 M=2*64
50705 E2=EN : IF E2<0 THEN E2=0
50710 ?@M,  "ShipX:";X(0);"Shot TXY:";T(1);X(1);Y(1);"FR:";FR;"KZ:";KZ;"  ";
50740 IF EN > 0 THEN ?@M-64, "Enemy:";"XY";X(EN);Y(EN);"T";T(EN);"DXY";DX(EN);DY(EN);"  ";
50900 RETURN

51000 REM Actions Display
51150 GOSUB 51500
51200 ?@MM, MS$;
51250 MS=6
51300 RETURN

51500 ?@MM, "               ";
51550 RETURN

52000 IF MS>0 THEN MS=MS-1
52050 IF MS=0 GOSUB 51500 ELSE ?@MM, MS$;"  ";
52100 RETURN

